# AchtDamen_doof_frueh_testen.py
### Hier werden jeweils nur die nachfolgenden Felder verwendet.
### Etwas bessere Version, bei der frueher gestestet wird.

# iterative Ueberarbeitung der Funktion zulaessig


### ===== Suchraum ==================================================
def erzeugeFeld(maxZahl):
    feld=[]
    for i in range(1,maxZahl+1):
        zeile=[]
        for j in range(1,maxZahl+1):
            feld.append([i, j])
    return feld
    
### ===== Tiefensuche ================================================
# Die Rekursion verwendet die nachfolgenden Felder.

def tiefensuche(maxZahl=4):
    def intern(alternativen, belegt):
        if len(belegt)==maxZahl:
            if zulaessig(belegt):
                return belegt
            return False
        if len(alternativen)==0:
            return False
        if not zulaessig(belegt):
            return False
        versuch = intern(alternativen[1:], [alternativen[0]]+belegt)
        if versuch:
            return versuch
        else:
            return intern(alternativen[1:], belegt)
    return intern(erzeugeFeld(maxZahl), [])

### ===== zulaessig ================================================
# Es wird nacheinander geprueft, ob sich Zeilen- oder Spaltenindizes
# und Diagonalendifferenzen wiederholen.
# uebergeben wird die liste der Belegungen
def zulaessig(belegt):
    for i in range(len(belegt)-1):
        for j in range(i+1, len(belegt)):
            x1,y1=belegt[i]
            x2,y2=belegt[j]
            ##input(((x1,y1),(x2,y2)))
            if x1==x2: return False          # gleiche Zeile
            if y1==y2: return False          # gleiche Spalte
            if x1-y1 == x2-y2: return False  # gleiche Diagonale ru
            if x1+y1 == x2+y2: return False  # gleiche Diagonale lu
    return True

### ===== Darstellung ============================================
def zeigeFeld(damen):
    damen.reverse()
    print(damen)
    for i in range(len(damen)):
        for j in range(len(damen)):
            if damen[i][1]-1==j: print('D', end=' ')
            else: print('*', end=' ')
        print()        

### ==============================================================
zeigeFeld(tiefensuche(5))

